import { mixinPropertyUtils } from './properties'
import obj from 'lodash/object'
import omit from 'lodash/omit'

export const createEntity = (object = {}, includeChain = true) => {
  const instance = mixinPropertyUtils(Object.assign({}, object), false)

  Object.keys(obj).forEach(
    (meth) => instance.hide(meth, (...args) => obj[meth](instance, ...args))
  )

  if (includeChain) {
    instance.hideGetter('chain', () => require('lodash').chain(instance))
  }

  instance.hide('toJSON', () => omit(instance, 'chain'))

  return instance
}

export default createEntity
