import every from 'lodash/every'
import isRegExp from 'lodash/isRegExp'
import isFunction from 'lodash/isFunction'
import isArray from 'lodash/isArray'
import isString from 'lodash/isString'

export const pathMatcher = (rule, subject) => {
  if (isRegExp(rule)) {
    return rule.test(subject)
  } else if (isFunction(rule)) {
    return !!rule(subject)
  } else if (isArray(rule)) {
    return every(rule, (condition) => pathMatcher(condition, subject))
  } else if (isString(rule)) {
    return new RegExp(rule).test(subject)
  } else {
    throw new Error('Invalid include / exclude rule')
  }
}

export default pathMatcher
