/* eslint-disable */
// @copyright https://github.com/frostney/require-webpack-compat

var path = require('path');

if (typeof __non_webpack_require__ === 'undefined') {
  global.__non_webpack_require__ = require
}

module.exports = function(module, req) {
  if (typeof req.context === 'function')  {
    return req
  }

  const getFolderContents = (folder, recursive) => {
    var fs = require('fs');

    return fs.readdirSync(folder).reduce(function(list, file) {

      var name = path.resolve(folder, file);
      var isDir = fs.statSync(name).isDirectory();

      return list.concat((isDir && recursive) ? getFolderContents(name, recursive) : [name]);
    }, []);
  };

  req.context = req.context || function(folder, recursive, pattern) {
    var normalizedFolder = path.resolve(module.filename ? module.filename : process.cwd(), folder);
    var folderContents = getFolderContents(normalizedFolder, recursive)
    .filter(function(item) {
      // Don't include current file
      if (item === module.filename) {
        return false;
      }

      return pattern.test(item);
    });

    var keys = function() {
      return folderContents;
    };

    var returnContext = function returnContext(item) {
      return __non_webpack_require__(item);
    };

    returnContext.keys = keys;

    return returnContext;
  };

  return req;
};
