const { join } = require('path')
const { api } = require('skypager-webpack')

module.exports = function (env, options = {}) {
  return api()
    .target('node')
    .externals(require.resolve('./package.json'))
    .context(__dirname)
    .entry({
      index: 'index.js',
      properties: 'properties.js',
      query: 'query.js',
      registry: 'registry.js',
      'webpack-compat': 'webpack-compat.js',
      router: 'router.js',
      entity: 'entity.js',
      string: 'string.js',
      packages: 'packages.js',
      'path-matcher': 'path-matcher.js',
      testRule: 'path-matcher.js',
      inflect: 'inflect.js',
    })
    .modules(
      join(__dirname, 'src')
    )
    .output({
      path: join(__dirname, 'lib'),
      filename: '[name].js',
    })
    .loader('babel', '.js', {
      include: [
        join(__dirname, 'src'),
      ],
      exclude: [
        /node_modules/,
      ],
    })
    .getConfig()
}
